"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCustomWebpackVersion = exports.ngAdd = void 0;
const tasks_1 = require("@angular-devkit/schematics/tasks");
const utils_1 = require("../utils");
function ngAdd(options) {
    return (host, context) => {
        const ngCoreVersionTag = utils_1.getPackageVersionFromPackageJson(host, '@angular/core');
        const angularDependencyVersion = ngCoreVersionTag || `0.0.0-NG`;
        if (angularDependencyVersion === '0.0.0-NG') {
            throw new Error('@angular/core version is not supported.');
        }
        utils_1.addPackageToPackageJson(host, 'angular-custom-webpack-chaining', getCustomWebpackVersion(angularDependencyVersion), 'devDependencies');
        context.addTask(new tasks_1.NodePackageInstallTask());
        context.addTask(new tasks_1.RunSchematicTask('angular-custom-webpack-chaining', 'ng-add-custom-webpack', {
            project: options.project,
            path: 'extra-webpack.config.js'
        }));
        /* context.addTask(new RunSchematicTask( */
        /* 	'add-chain', */
        /* 	{ */
        /* 		project: options.project, */
        /* 		path: 'webpack1.config.js', */
        /* 		architect: 'build' */
        /* 	} */
        /* )); */
        utils_1.setAllCustomWebpackChainingToAngularJson(host, options.project);
    };
}
exports.ngAdd = ngAdd;
function getCustomWebpackVersion(ver) {
    const [major, minor, patch] = (ver.replace(/(\^|\~)/, '')).split('.');
    switch (major) {
        case '10': return '~0.1000.x';
        case '11': return '~0.1100.x';
        default: throw new Error('@angular/core version is not supported.');
    }
}
exports.getCustomWebpackVersion = getCustomWebpackVersion;
//# sourceMappingURL=index.js.map